mod Ex08a logic: 'cl'

incl Mtex

incl Mauxa

loc rem 
  \para \bf  8. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 12.4.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para triedenie zoznamov, 
   \item \para binárne vyhľadávacie stromy. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 2 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 0 
  \end
  \para Odovzdať do 2.5.2017 (utorok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Lists.  \end 

rem 
  \para \bf  Section. Sorting of Lists.  \end 

rem 
  \para \bf  [CL] Remark.  \end See the auxiliary module \it  Maux*  \end. 

rem 
  \para \bf  Subsection. Insertion Sort.  \end 

rem 
  \para \bf  Insertion function.  \end 

fun/2 Insert 
  Insert(a,x) = Foo

rem 
  \para \bf  Exercise.  \end Prove 
  \eq* 
    Perm(Insert(a,x),a,x)
  \end
  \eq* 
    Ord(x) -> Ord Insert(a,x)
  \end

lemma Lemma_insert_perm
  Perm(i,a,w) -> Perm((v,i),a,v,w)
proof 
 use Perm_cancel_conc_elem.0; 0; v; i; a,0; w proved..

thm Insert_perm
  Perm(Insert(a,x),a,x)

thm Insert_ord
  Ord(x) -> Ord Insert(a,x)
proof  proved.

rem 
  \para \bf  Insertion sort.  \end 

fun Isort 
  Isort(x) = Foo

rem 
  \para \bf  Exercise. \it  (2 points)  \end  \end Prove 
  \eq* 
    Perm(Isort(x),x)
  \end
  \eq* 
    Ord Isort(x)
  \end

lemma Lemma_isort_perm
  Perm(iw,w) & Perm(ivw,v,iw) -> Perm(ivw,v,w)
proof 
 use Perm_trans; ivw; v,iw; v,w
  use Perm_pair; iw; w; v proved...

thm Isort_perm
  Perm(Isort(x),x)

thm Isort_ord
  Ord Isort(x)
proof  proved.

rem 
  \para \bf  Subsection. Merge Sort.  \end 

rem 
  \para \bf  Exercise.  \end \header* fun/2 Merge  \end Implement merge sort; 
  that is, define the function \ft Msort(x) \end such that 
  \eq* 
    Perm(Msort(x),x)
  \end
  \eq* 
    Ord Msort(x)
  \end
  \para with the help of the function \ft Msplit(x) \end: 
  \eq* 
    \e y\e z Msplit(x) = y,z
  \end
  \eq* 
    Msplit(x) = y,z -> Perm(x,y++z)
  \end
  \eq* 
    Msplit(x) = y,z -> L(y) = L(z) \/ L(y) = L(z)+1
  \end
  \para and the function \ft Merge(x,y) \end: 
  \eq* 
    Perm(Merge(x,y),x++y)
  \end
  \eq* 
    Ord(x) & Ord(y) -> Ord Merge(x,y)
  \end

fun Msplit 
  Msplit(x) = Foo

fun/2 Merge 
  Merge(x,y) = Foo

fun Msort 
  Msort(x) = Foo

