mod Ex08b logic: 'cl'

incl Mtex

incl Mtexbt

incl Mauxb

loc rem 
  \para \bf  8. CVIČENIE Z PREDMETU 1-AIN-470 ŠPECIFIKÁCIA A VERIFIKÁCIA 
  PROGRAMOV  \end 

loc rem 
  \para* \it  Meno:  \end 
  \para* \it  Verzia CL:  \end 5.81.21 
  \para* \it  Dátum:  \end streda 12.4.2017 
  \para* \it  WWW:  \end 
  http://www.ii.fmph.uniba.sk/cl/view.php/courses/1-AIN-470-svp/1617ls/?lang=sk 
  \para* \it  Kontakt:  \end Jan.Komara(at)fmph.uniba.sk 

loc rem 
  \para \bf  Úvodná poznámka.  \end Toto cvičenie je venované týmto 
  témam: 
  \items 
   \item \para triedenie zoznamov, 
   \item \para binárne vyhľadávacie stromy. 
  \end
  \para Zadanie sa skladá z týchto súborov: 
  \items 
   \item \para Súbory \it  mtex*.cl  \end obsahujú makrá pre CL-TeX. 
   \item \para Súbory \it  maux*.cl  \end obsahujú definície a vlastnosti 
         pomocných funkcií a predikátov. 
   \item \para Súbory \it  ex*.cl  \end obsahujú úlohy, ktoré máte riešiť 
         na tomto cvičení. 
   \item \para Súbory \it  mlogic*.cl  \end obsahujú popis verifikačnej 
         časti systému CL. 
   \item \para Súbor \it  msyntax.cl  \end obsahuje základnú syntax systému 
         CL. 
  \end
  \para Tieto súbory sa musia skompilovať v správnom poradí. Presný postup 
  je uvedený v súbore \it  readme.txt  \end. 

loc rem 
  \para \bf  Hodnotenie.  \end 
  \items 
   \item \para Počet bodov za úlohy v tomto súbore: 0 
   \item \para Počet bodov za prémiove úlohy v tomto súbore:: 3 
  \end
  \para Odovzdať do 2.5.2017 (utorok) do 12:00. 

loc rem 
  ******************************************************************************
  ********************************* EXERCISES **********************************
  ******************************************************************************

rem 
  \para \bf  Literature.  \end 
  \items 
   \item \para \it  [1]  \end J. Komara. Specification and Verification of 
         Programs. Online. 
   \item \para \it  [2]  \end Ján Kľuka. Úvod do deklaratívneho 
         programovania. Online. 
  \end

rem 
  \para \bf  Chapter. Programs Operating on Trees.  \end 

rem 
  \para \bf  Section. Binary Search Trees.  \end 

rem 
  \para \bf  [CL] Remark.  \end See the auxiliary module \it  Maux*  \end. 

rem 
  \para \bf  Membership in binary search trees.  \end 
  \header* pred/2 Inbst 'Tex_p2_bt_inbst_s' \end Define the predicate 
  \ft Inbst(x,t) \end such that 
  \eq* 
    Bst(t) -> Inbst(x,t) <-> Inbt(x,t)
  \end

pred/2 Inbst 'Tex_p2_bt_inbst_s'
  Inbst(x,t) <-> Poo

rem 
  \para \bf  Insertion in binary search trees.  \end 

fun/2 Insert 'Tex_f2_bt_insert'
  Insert(E,x) = Nd(x,E,E)
  Insert(Nd(y,l,r),x) = Nd(y,Insert(l,x),r) <- x < y
  Insert(Nd(y,l,r),x) = Nd(y,l,r) <- x = y
  Insert(Nd(y,l,r),x) = Nd(y,l,Insert(r,x)) <- x > y

rem 
  \para \bf  Exercise. \it  (bonus 3 points)  \end  \end Prove 
  \eq* 
    Bst(t) -> Bst Insert(t,x)
  \end
  \eq* 
    Bst(t) -> Inbt(y,Insert(t,x)) <-> Inbt(y,t) \/ y = x
  \end

thm Insert_bst
  Bst(t) -> Bst Insert(t,x)

thm Insert_inbt
  Bst(t) -> Inbt(y,Insert(t,x)) <-> Inbt(y,t) \/ y = x

rem 
  \para \bf  Extraction of the maximal element from binary search trees.  \end 
  Define the function \ft Emax(t) \end such that 
  \eq* 
    Bst(t1) & t1 != E -> \e x2\e t2 Emax(t1) = x2,t2
  \end
  \eq* 
    Bst(t1) & t1 != E & Emax(t1) = x2,t2 -> Inbt(x2,t1)
  \end
  \eq* 
    Bst(t1) & t1 != E & Emax(t1) = x2,t2 & Inbt(y,t1) -> y <= x2
  \end
  \eq* 
    Bst(t1) & t1 != E & Emax(t1) = x2,t2 -> Bst(t2)
  \end
  \eq* 
    Bst(t1) & t1 != E & Emax(t1) = x2,t2 -> Inbt(y,t2) <-> Inbt(y,t1) & y != x2
  \end

fun Emax 
  Emax(t) = Foo

rem 
  \para \bf  Joining two binary search trees.  \end 
  \header* fun/2 Join 'Tex_f2_bt_join' \end 
  \header* pred/2 Ltb 'Tex_p2_bt_ltb' \end Define the function 
  \ft Join(t1,t2) \end such that 
  \eq* 
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Bst Join(t1,t2)
  \end
  \eq* 
    Bst(t1) & Bst(t2) & Ltb(t1,t2) -> Inbt(x,Join(t1,t2)) <-> 
    Inbt(x,t1) \/ Inbt(x,t2)
  \end
  \para where 
  \eq* 
    Ltb(t1,t2) <-> \a x1\a x2(Inbt(x1,t1) & Inbt(x2,t2) -> x1 < x2)
  \end
  \para Define the operation with the help of the function \ft Emaxt(t) \end. 

fun/2 Join 'Tex_f2_bt_join'
  Join(t1,t2) = Foo

rem 
  \para \bf  Deletion in binary search trees.  \end 
  \header* fun/2 Delete 'Tex_f2_bt_delete' \end Define the function 
  \ft Delete(t,x) \end such that 
  \eq* 
    Bst(t) -> Bst Delete(t,x)
  \end
  \eq* 
    Bst(t) -> Inbt(y,Delete(t,x)) <-> Inbt(y,t) & y != x
  \end

fun/2 Delete 'Tex_f2_bt_delete'
  Delete(t,x) = Foo

loc rem 
  ******************************************************************************
  ********************************* DEBUGGING **********************************
  ******************************************************************************

loc fun/2 Ins 
  Ins(t,0) = t
  Ins(t,v,w) = Ins(Insert(t,v),w)

loc fun/2 Del 
  Del(t,0) = t
  Del(t,v,w) = Del(Delete(t,v),w)

loc rem 
  Useful queries:
  Ins(E,4,2,6,1,5,3,7,0) = t1:Bt
  Ins(E,4,2,6,1,5,3,7,0) = t1:Bt & Del(t1,4,5,3,1,2,6,7,0) = t2:Bt

